#!/usr/bin/python
# -*- coding: utf-8 -*-

import sys
import getopt

out = sys.stdout

opts, args = getopt.getopt(sys.argv[1:], "43", ["A4", "A3"])
page = 'A4'
for o, a in opts:
    if o in ("-4", "--A4"):
      page = 'A4'
    if o in ("-3", "--A3"):
      page = 'A3'


BoundingBox = {'A4':'0 0 595 842', 'A3':'0 0 842 1191'}

out.write(
"""%!PS-Adobe-3.0 EPSF-3.0
%%Creator: eps-combine.py
%%Pages: """ + str(len(args)) + """
%%DocumentData: Clean7Bit
%%BoundingBox: """ + BoundingBox[page] + """
%%DocumentPaperSizes: """ + page.lower() + """
%%LanguageLevel: 2
%%EndComments
""")

page_nbr = 0

for file in args:
  page_nbr += 1
  out.write('%%%%Page: %d %d\n' % (page_nbr, page_nbr))
  out.write('gsave\n')

  in_data = 0
  for line in open(file).readlines():
    if line.startswith(r'%%DataBegin'):
      in_data = 1
    if not in_data and \
      (line.startswith('%%') or line.startswith('showpage')):
        line = '%---' + line
    if line.startswith(r'%%DataEnd'):
      in_data = 0

    out.write(line)

  out.write('showpage grestore\n')
  out.write('%%PageTrailer\n')

out.write(
"""
%%Trailer
%%EOF
""")

