#!/usr/bin/python
# -*- coding: utf-8 -*-

"""Yhdistää A4 ja A5/A5R sivuja sivua isommalle (A4-A3) sivulle."""
import sys, re, time, os

a4_height = 842

out = sys.stdout
size = None
page_size = 0 # count of A5s
list = []

for arg in sys.argv[1:]:
  if arg[:1] == '-':
    assert arg in ('-A5', '-A5R', '-A4')
    size = arg[1:]
    page_size += {'A5':1, 'A4':2}[size[:2]]
  else:
    assert size
    list.append((size, arg))

if len(list) > 1 and list[1][0] == 'A4':
  list = list[0:1] + list[2:] + list[1:2]

if page_size <= 2:
  page = 'A4'
elif page_size <= 4:
  page = 'A3'
else:
  raise ValueError

BoundingBox = {'A4':'0 0 595 842', 'A3':'0 0 842 1191'}
Rot = {'A5':0, 'A5R': 1, 'A4':1, 'A3':0}
Coord = {'A4': [(0,421), (0,0)], 'A3': [(0,595), (421,595), (0,0), (421,0)] }
Shift = {'A4': 421, 'A3': 595}

out.write(
"""%!PS-Adobe-3.0 EPSF-3.0
%%Creator: eps-combine.py
%%Pages: 1
%%DocumentData: Clean7Bit
%%BoundingBox: """ + BoundingBox[page] + """
%%DocumentPaperSizes: """ + page.lower() + """
%%LanguageLevel: 2
%%EndComments
%%Page: 1 1
""")


c = 0 # slot
for size, file in list:
  if page == 'A4' and size == 'A4':
    c += 1
  rotate = (Rot[size]) ^ (Rot[page])
  out.write('save %d %d translate ' % Coord[page][c])
  if rotate:
    out.write('0 %d translate -90 rotate ' % Shift[page])
  out.write('%% eps-combine: "%s"\n' % file)
  
  in_data = 0
  for line in open(file).readlines():
    if line.startswith(r'%%DataBegin'):
      in_data = 1
    if not in_data and \
      (line.startswith('%%') or line.startswith('showpage')):
        line = '%//' + line
    if line.startswith(r'%%DataEnd'):
      in_data = 0

    # Clean \r\n
    if line[-2:] == '\r\n':
      out.write(line[:-2] + '\n')
    else:
      out.write(line)

  out.write('restore %% eps-combine\n')
  c += 1
  if size == 'A4':
    c += 1

out.write(
"""showpage
%%PageTrailer
%%Trailer
%%EOF
""")

